using System;
using System.Drawing;
using System.Collections;

namespace _3_Polymorphism
{
  abstract class Shape
  {
    public Point Location;
    public Size sz;

    public virtual void Draw(Graphics g)
    {
    }
  }

  class Square : Shape
  {
    public override void Draw(Graphics g)
    {
      Pen p = new Pen(Color.Black, 3);
      g.DrawRectangle(p,
                      Location.X,
                      Location.Y,
                      sz.Width,
                      sz.Height);
      p.Dispose();
    }
  }

  class Pentagon : Shape
  {
    public override void Draw(Graphics g)
    {
      Pen p = new Pen(Color.Black, 3);
      Point[] pts = new Point[6];
      float a = 0;
      for (int c = 0; c < 5; c++)
      {
        pts[c] = new Point(
                  (int)(Location.X + ((sz.Width / 2) * Math.Cos(a)) + sz.Width/2),
                  (int)(Location.Y + ((sz.Height / 2) * Math.Sin(a))) + sz.Height/2);
        a += (float)Math.PI * 2 / 5;
      }
      pts[5] = pts[0];

      g.DrawPolygon(p, pts);
      p.Dispose();
    }
  }

  class ShapeCollection : CollectionBase
  {
    public void Add(Shape s)
    {
      List.Add(s);
    }
  }
}
